<!DOCTYPE html>
<html>
<head>
  <meta charset="utf-8">
  <meta name="generator" content="pandoc">
  <meta name="author" content="Winnie Hellmann">
  <meta name="dcterms.date" content="2019-04-23">
  <title>Wie macht GitLab mit GitLab GitLab?</title>
  <meta name="apple-mobile-web-app-capable" content="yes">
  <meta name="apple-mobile-web-app-status-bar-style" content="black-translucent">
  <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no, minimal-ui">
  <link rel="stylesheet" href="reveal.js/css/reveal.css">
  <style>
      code{white-space: pre-wrap;}
      span.smallcaps{font-variant: small-caps;}
      span.underline{text-decoration: underline;}
      div.column{display: inline-block; vertical-align: top; width: 50%;}
  </style>
  <style>
a.sourceLine { display: inline-block; line-height: 1.25; }
a.sourceLine { pointer-events: none; color: inherit; text-decoration: inherit; }
a.sourceLine:empty { height: 1.2em; }
.sourceCode { overflow: visible; }
code.sourceCode { white-space: pre; position: relative; }
div.sourceCode { margin: 1em 0; }
pre.sourceCode { margin: 0; }
@media screen {
div.sourceCode { overflow: auto; }
}
@media print {
code.sourceCode { white-space: pre-wrap; }
a.sourceLine { text-indent: -1em; padding-left: 1em; }
}
pre.numberSource a.sourceLine
  { position: relative; left: -4em; }
pre.numberSource a.sourceLine::before
  { content: attr(title);
    position: relative; left: -1em; text-align: right; vertical-align: baseline;
    border: none; pointer-events: all; display: inline-block;
    -webkit-touch-callout: none; -webkit-user-select: none;
    -khtml-user-select: none; -moz-user-select: none;
    -ms-user-select: none; user-select: none;
    padding: 0 4px; width: 4em;
    color: #aaaaaa;
  }
pre.numberSource { margin-left: 3em; border-left: 1px solid #aaaaaa;  padding-left: 4px; }
div.sourceCode
  {  }
@media screen {
a.sourceLine::before { text-decoration: underline; }
}
code span.al { color: #ff0000; font-weight: bold; } /* Alert */
code span.an { color: #60a0b0; font-weight: bold; font-style: italic; } /* Annotation */
code span.at { color: #7d9029; } /* Attribute */
code span.bn { color: #40a070; } /* BaseN */
code span.bu { } /* BuiltIn */
code span.cf { color: #007020; font-weight: bold; } /* ControlFlow */
code span.ch { color: #4070a0; } /* Char */
code span.cn { color: #880000; } /* Constant */
code span.co { color: #60a0b0; font-style: italic; } /* Comment */
code span.cv { color: #60a0b0; font-weight: bold; font-style: italic; } /* CommentVar */
code span.do { color: #ba2121; font-style: italic; } /* Documentation */
code span.dt { color: #902000; } /* DataType */
code span.dv { color: #40a070; } /* DecVal */
code span.er { color: #ff0000; font-weight: bold; } /* Error */
code span.ex { } /* Extension */
code span.fl { color: #40a070; } /* Float */
code span.fu { color: #06287e; } /* Function */
code span.im { } /* Import */
code span.in { color: #60a0b0; font-weight: bold; font-style: italic; } /* Information */
code span.kw { color: #007020; font-weight: bold; } /* Keyword */
code span.op { color: #666666; } /* Operator */
code span.ot { color: #007020; } /* Other */
code span.pp { color: #bc7a00; } /* Preprocessor */
code span.sc { color: #4070a0; } /* SpecialChar */
code span.ss { color: #bb6688; } /* SpecialString */
code span.st { color: #4070a0; } /* String */
code span.va { color: #19177c; } /* Variable */
code span.vs { color: #4070a0; } /* VerbatimString */
code span.wa { color: #60a0b0; font-weight: bold; font-style: italic; } /* Warning */
  </style>
  <link rel="stylesheet" href="reveal.js/css/theme/white.css" id="theme">
  <link rel="stylesheet" href="style.css"/>
  <!-- Printing and PDF exports -->
  <script>
    var link = document.createElement( 'link' );
    link.rel = 'stylesheet';
    link.type = 'text/css';
    link.href = window.location.search.match( /print-pdf/gi ) ? 'reveal.js/css/print/pdf.css' : 'reveal.js/css/print/paper.css';
    document.getElementsByTagName( 'head' )[0].appendChild( link );
  </script>
  <!--[if lt IE 9]>
  <script src="reveal.js/lib/js/html5shiv.js"></script>
  <![endif]-->
</head>
<body>
  <div class="reveal">
    <div class="slides">

<section id="title-slide">
  <h1 class="title">Wie macht GitLab mit GitLab GitLab?</h1>
  <p class="author">Winnie Hellmann</p>
  <p class="date">2019-04-23</p>
</section>

<section id="wie-macht-gitlab-mit-gitlab-gitlab" class="title-slide slide level1 white-text" data-background-image="https://about.gitlab.com/images/demo/demo-background-red.png" data-transition="zoom"><h1>Wie macht GitLab mit GitLab GitLab?</h1><script src="title-slide-hack.js"></script>
<p>Winnie Hellmann</p>
<p>2019-04-23</p></section>
<section id="devops-cycle" class="title-slide slide level1" data-transition="slide-in fade-out"><h1>DevOps cycle </h1><p><img data-src="devops-loop-and-spans-small.png" alt="devops cycle diagram" class="bonus-padding" /><br />
</p>
<p><a href="https://about.gitlab.com/stages-devops-lifecycle/" class="uri">https://about.gitlab.com/stages-devops-lifecycle/</a></p></section>
<section id="devops-cycle-1" class="title-slide slide level1" data-transition="none"><h1>DevOps cycle </h1><p><img data-src="dev-stages.png" alt="devops cycle diagram with dev stages highlighted" class="bonus-padding" /><br />
</p>
<p><a href="https://about.gitlab.com/stages-devops-lifecycle/" class="uri">https://about.gitlab.com/stages-devops-lifecycle/</a></p></section>
<section><section id="plan" class="title-slide slide level1"><h1>Plan<br />
</h1><p><img data-src="plan.png" alt="devops cycle diagram with Plan highlighted" class="bonus-padding" /><br />
</p>
<p><a href="https://about.gitlab.com/stages-devops-lifecycle/plan/" class="uri">https://about.gitlab.com/stages-devops-lifecycle/plan/</a></p></section><section id="new-issue" class="slide level2 no-heading">
<h2>New Issue</h2>
<figure>
<img data-src="bug-report.png" alt="screenshot of a bug report" /><figcaption>screenshot of a bug report</figcaption>
</figure>
<p><a href="https://about.gitlab.com/handbook/communication/#everything-starts-with-an-issue" class="uri">https://about.gitlab.com/handbook/communication/#everything-starts-with-an-issue</a></p>
<p><a href="https://docs.gitlab.com/ee/user/project/description_templates.html" class="uri">https://docs.gitlab.com/ee/user/project/description_templates.html</a></p>
</section><section id="labels" class="slide level2">
<h2>Labels</h2>
<figure>
<img data-src="issue-labels.png" alt="screenshot of labels on an issue" /><figcaption>screenshot of labels on an issue</figcaption>
</figure>
<p><a href="https://docs.gitlab.com/ee/development/contributing/issue_workflow.html" class="uri">https://docs.gitlab.com/ee/development/contributing/issue_workflow.html</a></p>
<p><a href="https://docs.gitlab.com/ee/user/project/labels.html" class="uri">https://docs.gitlab.com/ee/user/project/labels.html</a></p>
</section><section id="milestones" class="slide level2">
<h2>Milestones</h2>
<div class="columns">
<div class="column" style="width:50%;">
<p><img data-src="milestone-none.png" alt="screenshot of no assigned milestone" /> <img data-src="milestone-awaiting-demand.png" alt="screenshot of awaiting demand milestone" /></p>
</div><div class="column" style="width:50%;">
<p><img data-src="milestone-backlog.png" alt="screenshot of backlog milestone" /> <img data-src="milestone-release.png" alt="screenshot of release milestone" /></p>
</div>
</div>
<p><a href="https://about.gitlab.com/handbook/engineering/workflow/#scheduling-issues" class="uri">https://about.gitlab.com/handbook/engineering/workflow/#scheduling-issues</a></p>
<p><a href="https://docs.gitlab.com/ee/user/project/milestones/" class="uri">https://docs.gitlab.com/ee/user/project/milestones/</a></p>
</section><section id="issue-board" class="slide level2">
<h2>Issue Board</h2>
<p><a href="https://gitlab.com/groups/gitlab-org/-/boards/1030832?label_name%5B%5D=frontend"><img data-src="issue-board.png" alt="screenshot of issues in an issue board" /></a></p>
<p><a href="https://docs.gitlab.com/ee/user/project/issue_board.html" class="uri">https://docs.gitlab.com/ee/user/project/issue_board.html</a></p>
</section><section id="issue-assignees" class="slide level2">
<h2>Issue Assignee(s)</h2>
<div class="columns">
<div class="column" style="width:50%;">
<figure>
<img data-src="issue-assignee.png" alt="screenshot of issue assignee" /><figcaption>screenshot of issue assignee</figcaption>
</figure>
</div><div class="column" style="width:50%;">
<figure>
<img data-src="issue-multiple-assignees.png" alt="screenshot of multiple issue assignees" /><figcaption>screenshot of multiple issue assignees</figcaption>
</figure>
</div>
</div>
<p><a href="https://docs.gitlab.com/ee/user/project/issues/issue_data_and_actions.html#3-assignee" class="uri">https://docs.gitlab.com/ee/user/project/issues/issue_data_and_actions.html#3-assignee</a></p>
<p><a href="https://docs.gitlab.com/ee/user/project/issues/multiple_assignees_for_issues.html" class="uri">https://docs.gitlab.com/ee/user/project/issues/multiple_assignees_for_issues.html</a></p>
</section><section id="issue-dashboard" class="slide level2">
<h2>Issue Dashboard</h2>
<figure>
<img data-src="issue-dashboard.png" alt="screenshot of the issue dashboard" /><figcaption>screenshot of the issue dashboard</figcaption>
</figure>
<p><a href="https://docs.gitlab.com/ee/user/profile/preferences.html#default-dashboard" class="uri">https://docs.gitlab.com/ee/user/profile/preferences.html#default-dashboard</a> <a href="https://gitlab.com/gitlab-org/gitlab-ce/issues/60755" class="uri">https://gitlab.com/gitlab-org/gitlab-ce/issues/60755</a></p>
</section><section id="workflow-labels" class="slide level2">
<h2>Workflow Labels</h2>
<figure>
<img data-src="issue-board-workflow-labels.png" alt="screenshot of issue board showing workflow labels" /><figcaption>screenshot of issue board showing workflow labels</figcaption>
</figure>
<p><a href="https://about.gitlab.com/handbook/engineering/workflow/" class="uri">https://about.gitlab.com/handbook/engineering/workflow/</a></p>
<p><a href="https://docs.gitlab.com/ee/user/project/labels.html#scoped-labels-premium" class="uri">https://docs.gitlab.com/ee/user/project/labels.html#scoped-labels-premium</a></p>
</section></section>
<section><section id="create" class="title-slide slide level1"><h1>Create<br />
</h1><p><img data-src="create.png" alt="devops cycle diagram with Create highlighted" class="bonus-padding" /><br />
</p>
<p><a href="https://about.gitlab.com/stages-devops-lifecycle/create/" class="uri">https://about.gitlab.com/stages-devops-lifecycle/create/</a></p></section><section id="coden-coden-coden" class="slide level2">
<h2>coden, coden, coden…</h2>
<figure>
<img data-src="cat-typing.gif" alt="animation of a cat typing on a laptop" /><figcaption>animation of a cat typing on a laptop</figcaption>
</figure>
</section><section id="git-it" class="slide level2">
<h2>Git it</h2>
<pre class="shell"><code>$ git push
Enumerating objects: 87, done.
Counting objects: 100% (87/87), done.
Delta compression using up to 12 threads
Compressing objects: 100% (53/53), done.
Writing objects: 100% (53/53), 5.08 KiB | 69.00 KiB/s, done.
Total 53 (delta 48), reused 0 (delta 0)
remote:
remote: To create a merge request for winh-simplify-frontend-fixtures, visit:
remote:   https://gitlab.com/gitlab-org/gitlab-ce/merge_requests/new?merge_request%5Bsource_branch%5D=winh-simplify-frontend-fixtures
remote:</code></pre>
</section><section id="merge-request" class="slide level2">
<h2>Merge Request</h2>
<p><a href="https://gitlab.com/gitlab-org/gitlab-ce/merge_requests/27531"><img data-src="new-merge-request.png" alt="screenshot of new merge request" /></a></p>
</section><section id="review-comments" class="slide level2">
<h2>Review Comments</h2>
<figure>
<img data-src="review-comment.png" alt="screenshot of review comment" /><figcaption>screenshot of review comment</figcaption>
</figure>
<p><a href="https://docs.gitlab.com/ee/development/code_review.html" class="uri">https://docs.gitlab.com/ee/development/code_review.html</a></p>
<p><a href="https://docs.gitlab.com/ee/user/discussions/#merge-request-reviews-premium" class="uri">https://docs.gitlab.com/ee/user/discussions/#merge-request-reviews-premium</a></p>
</section></section>
<section><section id="verify" class="title-slide slide level1"><h1>Verify<br />
</h1><p><img data-src="verify.png" alt="devops cycle diagram with Verify highlighted" class="bonus-padding" /><br />
</p>
<p><a href="https://about.gitlab.com/stages-devops-lifecycle/verify/" class="uri">https://about.gitlab.com/stages-devops-lifecycle/verify/</a></p></section><section id="was-ist-verify" class="slide level2">
<h2>Was ist Verify?</h2>
<ul>
<li>Teil von GitLabs CI/CD (Continuous Integration / Continuous Delivery)</li>
<li>ursprünglich mit GitLab CI separates Produkt</li>
<li>inzwischen vollständig Integriert</li>
</ul>
</section><section id="wie-sieht-ci-aus" class="slide level2" data-transition="slide-in fade-out">
<h2>Wie sieht CI aus?</h2>
<figure>
<img data-src="infinite_battle.gif" alt="many small characters running around busy with different tasks" /><figcaption>many small characters running around busy with different tasks</figcaption>
</figure>
</section><section id="wie-sieht-ci-aus-1" class="slide level2" data-transition="fade-in slide-out">
<h2>Wie sieht CI aus?</h2>
<figure>
<img data-src="ci-cd-test-deploy-illustration_2x.png" alt="diagram of an assembly belt that represents CI pipelines" /><figcaption>diagram of an assembly belt that represents CI pipelines</figcaption>
</figure>
</section><section id="was-macht-ci" class="slide level2">
<h2>Was macht CI?</h2>
<ul>
<li>automatisierte Tests</li>
<li>statische Code-Analyse
<ul>
<li>potentielle Bugs</li>
<li>Sicherheitslücken</li>
<li>Lizenzprobleme</li>
</ul></li>
<li>Code-Style prüfen</li>
</ul>
</section><section id="wie-geht-ci" class="slide level2">
<h2>Wie geht CI?</h2>
<ul>
<li>in GitLab per Konfiguration in <code>.gitlab-ci.yml</code></li>
<li>üblicherweise eine pro Projekt</li>
<li>prinzipiell eine pro Branch bzw. Commit möglich</li>
</ul>
</section><section id="wie-geht-ci-1" class="slide level2">
<h2>Wie geht CI?</h2>
<ul>
<li>im einfachsten Fall:</li>
</ul>
<div class="sourceCode" id="cb2"><pre class="sourceCode yaml"><code class="sourceCode yaml"><a class="sourceLine" id="cb2-1" title="1"><span class="fu">mein job:</span></a>
<a class="sourceLine" id="cb2-2" title="2">  <span class="fu">script:</span></a>
<a class="sourceLine" id="cb2-3" title="3">    <span class="kw">-</span> echo <span class="st">&quot;Nichts tun.&quot;</span></a></code></pre></div>
<figure>
<img data-src="small-pipeline.png" alt="screenshot of pipeline with one job" /><figcaption>screenshot of pipeline with one job</figcaption>
</figure>
</section><section id="wie-geht-ci-2" class="slide level2">
<h2>Wie geht CI?</h2>
<figure>
<img data-src="small-pipeline-log.png" alt="screenshot of job log" /><figcaption>screenshot of job log</figcaption>
</figure>
</section><section id="wie-geht-parallelität" class="slide level2">
<h2>Wie geht Parallelität?</h2>
<div class="sourceCode" id="cb3"><pre class="sourceCode yaml"><code class="sourceCode yaml"><a class="sourceLine" id="cb3-1" title="1"><span class="fu">mein job:</span></a>
<a class="sourceLine" id="cb3-2" title="2">  <span class="fu">script:</span></a>
<a class="sourceLine" id="cb3-3" title="3">    <span class="kw">-</span> echo <span class="st">&quot;Nichts tun.&quot;</span></a>
<a class="sourceLine" id="cb3-4" title="4"></a>
<a class="sourceLine" id="cb3-5" title="5"><span class="fu">dein job:</span></a>
<a class="sourceLine" id="cb3-6" title="6">  <span class="fu">script:</span></a>
<a class="sourceLine" id="cb3-7" title="7">    <span class="kw">-</span> echo <span class="st">&quot;Viel tun.&quot;</span></a></code></pre></div>
<figure>
<img data-src="parallel-jobs.png" alt="screenshot of parallel pipeline jobs" /><figcaption>screenshot of parallel pipeline jobs</figcaption>
</figure>
</section><section id="wie-geht-parallelität-1" class="slide level2">
<h2>Wie geht Parallelität?</h2>
<div class="sourceCode" id="cb4"><pre class="sourceCode yaml"><code class="sourceCode yaml"><a class="sourceLine" id="cb4-1" title="1"><span class="fu">dein job:</span></a>
<a class="sourceLine" id="cb4-2" title="2">  <span class="fu">parallel:</span><span class="at"> </span><span class="dv">5</span></a>
<a class="sourceLine" id="cb4-3" title="3">  <span class="fu">script:</span></a>
<a class="sourceLine" id="cb4-4" title="4">    <span class="kw">-</span> echo <span class="st">&quot;Aufgabe ${CI_NODE_INDEX} von ${CI_NODE_TOTAL}&quot;</span></a></code></pre></div>
<figure>
<img data-src="many-parallel-jobs.png" alt="screenshot of parallel pipeline jobs" /><figcaption>screenshot of parallel pipeline jobs</figcaption>
</figure>
</section><section id="wie-geht-unparallelität" class="slide level2">
<h2>Wie geht Unparallelität?</h2>
<div class="sourceCode" id="cb5"><pre class="sourceCode yaml"><code class="sourceCode yaml"><a class="sourceLine" id="cb5-1" title="1"><span class="fu">mein job:</span></a>
<a class="sourceLine" id="cb5-2" title="2">  <span class="fu">stage:</span><span class="at"> test</span></a>
<a class="sourceLine" id="cb5-3" title="3">  <span class="fu">script:</span></a>
<a class="sourceLine" id="cb5-4" title="4">    <span class="kw">-</span> echo <span class="st">&quot;Nichts tun.&quot;</span></a>
<a class="sourceLine" id="cb5-5" title="5"></a>
<a class="sourceLine" id="cb5-6" title="6"><span class="fu">dein job:</span></a>
<a class="sourceLine" id="cb5-7" title="7">  <span class="fu">stage:</span><span class="at"> deploy</span></a>
<a class="sourceLine" id="cb5-8" title="8">  <span class="fu">script:</span></a>
<a class="sourceLine" id="cb5-9" title="9">    <span class="kw">-</span> echo <span class="st">&quot;Viel tun.&quot;</span></a></code></pre></div>
<figure>
<img data-src="two-stages.png" alt="screenshot of pipeline with two stages" /><figcaption>screenshot of pipeline with two stages</figcaption>
</figure>
</section><section id="wie-geht-unparallelität-1" class="slide level2">
<h2>Wie geht Unparallelität?</h2>
<div class="sourceCode" id="cb6"><pre class="sourceCode yaml"><code class="sourceCode yaml"><a class="sourceLine" id="cb6-1" title="1"><span class="fu">stages:</span></a>
<a class="sourceLine" id="cb6-2" title="2">  <span class="kw">-</span> zuerst</a>
<a class="sourceLine" id="cb6-3" title="3">  <span class="kw">-</span> zuzweit</a>
<a class="sourceLine" id="cb6-4" title="4"></a>
<a class="sourceLine" id="cb6-5" title="5"><span class="fu">mein job:</span></a>
<a class="sourceLine" id="cb6-6" title="6">  <span class="fu">stage:</span><span class="at"> zuerst</span></a>
<a class="sourceLine" id="cb6-7" title="7">  <span class="fu">script:</span></a>
<a class="sourceLine" id="cb6-8" title="8">    <span class="kw">-</span> echo <span class="st">&quot;Nichts tun.&quot;</span></a>
<a class="sourceLine" id="cb6-9" title="9"></a>
<a class="sourceLine" id="cb6-10" title="10"><span class="fu">dein job:</span></a>
<a class="sourceLine" id="cb6-11" title="11">  <span class="fu">stage:</span><span class="at"> zuzweit</span></a>
<a class="sourceLine" id="cb6-12" title="12">  <span class="fu">script:</span></a>
<a class="sourceLine" id="cb6-13" title="13">    <span class="kw">-</span> echo <span class="st">&quot;Viel tun.&quot;</span></a></code></pre></div>
</section><section id="wie-entstehen-neue-pipelines" class="slide level2">
<h2>Wie entstehen neue Pipelines?</h2>
<ul>
<li>der Storch bringt sie nicht</li>
<li>jeder <code>git push</code> erzeugt eine neue Pipeline</li>
<li>Pipelines können <a href="https://docs.gitlab.com/ee/ci/pipelines.html#manually-executing-pipelines">manuell erzeugt werden</a></li>
<li>oder <a href="https://docs.gitlab.com/ee/api/pipelines.html#create-a-new-pipeline">per API</a></li>
<li>cron-artige <a href="https://docs.gitlab.com/ee/user/project/pipelines/schedules.html">Pipeline schedules</a></li>
</ul>
</section><section id="trödeln" class="slide level2">
<h2>Trödeln</h2>
<div class="sourceCode" id="cb7"><pre class="sourceCode yaml"><code class="sourceCode yaml"><a class="sourceLine" id="cb7-1" title="1"><span class="fu">moment:</span></a>
<a class="sourceLine" id="cb7-2" title="2">  <span class="fu">when:</span><span class="at"> delayed</span></a>
<a class="sourceLine" id="cb7-3" title="3">  <span class="fu">start_in:</span><span class="at"> 30 minutes</span></a>
<a class="sourceLine" id="cb7-4" title="4">  <span class="fu">script:</span></a>
<a class="sourceLine" id="cb7-5" title="5">    <span class="kw">-</span> echo <span class="st">&quot;Wer hat an der Uhr gedreht?&quot;</span></a></code></pre></div>
<p><a href="https://docs.gitlab.com/ee/ci/yaml/#whendelayed" class="uri">https://docs.gitlab.com/ee/ci/yaml/#whendelayed</a></p>
</section><section id="handarbeit" class="slide level2">
<h2>Handarbeit</h2>
<div class="sourceCode" id="cb8"><pre class="sourceCode yaml"><code class="sourceCode yaml"><a class="sourceLine" id="cb8-1" title="1"><span class="fu">galvanize:</span></a>
<a class="sourceLine" id="cb8-2" title="2">  <span class="fu">when:</span><span class="at"> manual</span></a>
<a class="sourceLine" id="cb8-3" title="3">  <span class="fu">script:</span></a>
<a class="sourceLine" id="cb8-4" title="4">    <span class="kw">-</span> echo <span class="st">&quot;Push the button!&quot;</span></a></code></pre></div>
<figure>
<img data-src="manual-job.png" alt="screenshot of manual pipeline job" /><figcaption>screenshot of manual pipeline job</figcaption>
</figure>
<p><a href="https://docs.gitlab.com/ee/ci/yaml/#whenmanual" class="uri">https://docs.gitlab.com/ee/ci/yaml/#whenmanual</a></p>
</section><section id="inklusion-und-exklusion" class="slide level2">
<h2>Inklusion und Exklusion</h2>
<div class="sourceCode" id="cb9"><pre class="sourceCode yaml"><code class="sourceCode yaml"><a class="sourceLine" id="cb9-1" title="1"><span class="fu">harte Arbeit:</span></a>
<a class="sourceLine" id="cb9-2" title="2">  <span class="fu">script:</span></a>
<a class="sourceLine" id="cb9-3" title="3">    <span class="kw">-</span> echo <span class="st">&quot;Schaffe, schaffe, Häusle baue&quot;</span></a>
<a class="sourceLine" id="cb9-4" title="4">  <span class="fu">except:</span></a>
<a class="sourceLine" id="cb9-5" title="5">    <span class="kw">-</span> master</a>
<a class="sourceLine" id="cb9-6" title="6">  <span class="fu">only:</span></a>
<a class="sourceLine" id="cb9-7" title="7">    <span class="kw">-</span> apprentice</a></code></pre></div>
<p><a href="https://docs.gitlab.com/ee/ci/yaml/#onlyexcept-basic" class="uri">https://docs.gitlab.com/ee/ci/yaml/#onlyexcept-basic</a></p>
</section><section id="advanced-awesomeness" class="slide level2">
<h2>Advanced Awesomeness</h2>
<ul>
<li><a href="https://docs.gitlab.com/ee/ci/yaml/#variables">Variablen</a>: Verhalten und Geheimnisse</li>
<li><a href="https://docs.gitlab.com/ee/ci/yaml/#artifacts">Artefakte</a>: Dateien ausspucken</li>
<li><a href="https://docs.gitlab.com/ee/ci/yaml/#cache">Caching</a>: Dateien zwischen Pipelines austauschen</li>
<li><a href="https://docs.gitlab.com/ee/ci/yaml/#extends">Extend</a>: Komplexe Jobs bauen</li>
<li><a href="https://docs.gitlab.com/ee/ci/yaml/#include">Include</a>: Komplexe Konfigurationen bauen</li>
<li><a href="https://docs.gitlab.com/ee/ci/triggers/">Pipeline Triggers</a>: Pipelines über mehrere Projekte</li>
</ul>
</section><section id="gitlab-pipeline" class="slide level2">
<h2>GitLab Pipeline</h2>
<figure>
<img data-src="pipeline.png" alt="screenshot of a GitLab pipeline" style="height: 75vh;" /><figcaption>screenshot of a GitLab pipeline</figcaption>
</figure>
</section><section id="gitlab-pipeline-1" class="slide level2">
<h2>GitLab Pipeline</h2>
<pre><code>build:
- review-docs-deploy-manual

prepare:
- compile-assets
- retrieve-tests-metadata
- setup-test-env

test:
- cache gems
- code_quality
- db:check-schema-pg
- db:migrate:reset-mysql
- db:migrate:reset-pg
- db:rollback-mysql
- db:rollback-pg
- dependency_scanning
- docs lint
- gitlab:assets:compile
- gitlab:setup-mysql
- gitlab:setup-pg
- gitlab_git_test
- jest
- karma
- migration:path-mysql
- migration:path-pg
- no_ee_check
- package-and-qa
- qa-frontend-node:8
- qa-frontend-node:10
- qa-frontend-node:latest
- qa:internal
- qa:selectors
- rspec-fast-spec-helper
- rspec-mysql
- rspec-mysql-quarantine
- rspec-pg
- rspec-pg-/50
- rspec-pg-quarantine
- sast
- static-analysis

post-test:
- coverage
- jsdoc
- lint:javascript:report
- update-tests-metadata

pages:
- pages

post-cleanup:
- review-docs-cleanup

deploy:
- pages:deploy</code></pre>
</section><section id="gitlab-pipeline-2" class="slide level2">
<h2>GitLab Pipeline</h2>
<div class="sourceCode" id="cb11"><pre class="sourceCode yaml"><code class="sourceCode yaml"><a class="sourceLine" id="cb11-1" title="1"><span class="fu">image:</span><span class="at"> </span><span class="st">&quot;dev.gitlab.org:5005/gitlab/gitlab-build-images:ruby-2.5.3-golang-1.11-git-2.21-chrome-71.0-node-10.x-yarn-1.12-postgresql-9.6-graphicsmagick-1.3.29&quot;</span></a>
<a class="sourceLine" id="cb11-2" title="2"></a>
<a class="sourceLine" id="cb11-3" title="3"><span class="co"># ...</span></a>
<a class="sourceLine" id="cb11-4" title="4"></a>
<a class="sourceLine" id="cb11-5" title="5"><span class="fu">include:</span></a>
<a class="sourceLine" id="cb11-6" title="6">  <span class="kw">-</span> <span class="fu">local:</span><span class="at"> .gitlab/ci/global.gitlab-ci.yml</span></a>
<a class="sourceLine" id="cb11-7" title="7">  <span class="kw">-</span> <span class="fu">local:</span><span class="at"> .gitlab/ci/cng.gitlab-ci.yml</span></a>
<a class="sourceLine" id="cb11-8" title="8">  <span class="kw">-</span> <span class="fu">local:</span><span class="at"> .gitlab/ci/docs.gitlab-ci.yml</span></a>
<a class="sourceLine" id="cb11-9" title="9">  <span class="kw">-</span> <span class="fu">local:</span><span class="at"> .gitlab/ci/frontend.gitlab-ci.yml</span></a>
<a class="sourceLine" id="cb11-10" title="10">  <span class="kw">-</span> <span class="fu">local:</span><span class="at"> .gitlab/ci/pages.gitlab-ci.yml</span></a>
<a class="sourceLine" id="cb11-11" title="11">  <span class="kw">-</span> <span class="fu">local:</span><span class="at"> .gitlab/ci/qa.gitlab-ci.yml</span></a>
<a class="sourceLine" id="cb11-12" title="12">  <span class="kw">-</span> <span class="fu">local:</span><span class="at"> .gitlab/ci/reports.gitlab-ci.yml</span></a>
<a class="sourceLine" id="cb11-13" title="13">  <span class="kw">-</span> <span class="fu">local:</span><span class="at"> .gitlab/ci/rails.gitlab-ci.yml</span></a>
<a class="sourceLine" id="cb11-14" title="14">  <span class="kw">-</span> <span class="fu">local:</span><span class="at"> .gitlab/ci/review.gitlab-ci.yml</span></a>
<a class="sourceLine" id="cb11-15" title="15">  <span class="kw">-</span> <span class="fu">local:</span><span class="at"> .gitlab/ci/setup.gitlab-ci.yml</span></a>
<a class="sourceLine" id="cb11-16" title="16">  <span class="kw">-</span> <span class="fu">local:</span><span class="at"> .gitlab/ci/test-metadata.gitlab-ci.yml</span></a></code></pre></div>
<p><a href="https://gitlab.com/gitlab-org/gitlab-ce/blob/master/.gitlab-ci.yml" class="uri">https://gitlab.com/gitlab-org/gitlab-ce/blob/master/.gitlab-ci.yml</a></p>
</section></section>
<section id="fragen" class="title-slide slide level1"><h1>Fragen?</h1><p>später gerne an:<br />
<code>winnie(🐒)gitlab📍com</code></p></section>
    </div>
  </div>

  <script src="reveal.js/lib/js/head.min.js"></script>
  <script src="reveal.js/js/reveal.js"></script>

  <script>

      // Full list of configuration options available at:
      // https://github.com/hakimel/reveal.js#configuration
      Reveal.initialize({
        // Push each slide change to the browser history
        history: true,
        // Transition style for full page slide backgrounds
        backgroundTransition: 'none', // none/fade/slide/convex/concave/zoom
        math: {
          mathjax: 'https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.2/MathJax.js',
          config: 'TeX-AMS_HTML-full',
          tex2jax: {
            inlineMath: [['\\(','\\)']],
            displayMath: [['\\[','\\]']],
            balanceBraces: true,
            processEscapes: false,
            processRefs: true,
            processEnvironments: true,
            preview: 'TeX',
            skipTags: ['script','noscript','style','textarea','pre','code'],
            ignoreClass: 'tex2jax_ignore',
            processClass: 'tex2jax_process'
          },
        },

        // Optional reveal.js plugins
        dependencies: [
          { src: 'reveal.js/lib/js/classList.js', condition: function() { return !document.body.classList; } },
          { src: 'reveal.js/plugin/zoom-js/zoom.js', async: true },
          { src: 'reveal.js/plugin/math/math.js', async: true },
          { src: 'reveal.js/plugin/notes/notes.js', async: true }
        ]
      });
    </script>
    </body>
</html>
